Attribute VB_Name = "aisa06w"
'*****************************************************************************
'* aisa06w.bas                                                               *
'*                                                                           *
'* aISA-A06W/H                                                           *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/05/12                                                           *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA06_DLL_NAME = "aisa06.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const AISA06_MAX_CH_W = 4  ' aISA-A06W̃`l
Global Const AISA06_MAX_CH_H = 2  ' aISA-A06H̃`l

Global Const AISA06_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    aisa06.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wDllOpen() As Boolean

    Aisa06wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA06_DLL_NAME)
    If hDLL = 0 Then Exit Function

    If Aisa06wGetDllExportFunc() = False Then
        Aisa06wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa06wDllOpen = True

End Function

'*****************************************************************************
'*    aisa06.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wDllClose() As Boolean

    Aisa06wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa06wDllClose = False

End Function

'*****************************************************************************
'*    aISA-A06W/H DLL,Vxd̃o[Wԍ擾                            *
'*    pdwDllVersion DLLo[Wԍi[                              *
'*        pdwVxdVersion Vxdo[Wԍi[                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wGetVersion(pdwDllVersion As Long, pdwVxdVersion As Long) As Boolean

    Aisa06wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa06GetVersion(pdwDllVersion, pdwVxdVersion) = 0 Then Exit Function

    Aisa06wGetVersion = True

End Function

'*****************************************************************************
'*    aISA-A06W/H̔Cӂ̃foCX̎gp錾                            *
'*    pwLogSlot gpfoCXi[AhX                       *
'*        hWnd      bZ[W󂯎EBhEnh                   *
'*        uWMBase   bZ[WID̊l                                     *
'*        pvInitArg ̂߂̗\                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wCreate(pwLogSlot As Integer, hWnd As Long, uWMBase As Long, pvInitArg As Long) As Boolean
    
    Aisa06wCreate = False

    If hDLL = 0 Then Exit Function

    If Aisa06Create(pwLogSlot, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function

    Aisa06wCreate = True

End Function

'*****************************************************************************
'*    aISA-A06W/H̔Cӂ̃foCX̎gpJ                            *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wClose(wLogSlot As Integer) As Boolean
    
    Aisa06wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa06Close(wLogSlot) = 0 Then Exit Function

    Aisa06wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pResInfo \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wGetResource(wLogSlot As Integer, pResInfo As AISA06RESOURCE) As Boolean

    Aisa06wGetResource = False

    If hDLL = 0 Then Exit Function

    If Aisa06GetResource(wLogSlot, pResInfo) = 0 Then Exit Function

    Aisa06wGetResource = True

End Function
'*****************************************************************************
'*    o̓f[^̐ݒ                                                   *
'*    wLogSlot _Xbg                                              *
'*        wChData  ݃`l(0 ` 3)                                  *
'*        wDaData  D/A݃f[^                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wSetData(wLogSlot As Integer, wChData As Integer, wDaData As Integer) As Boolean

    Aisa06wSetData = False

    If hDLL = 0 Then Exit Function

    If Aisa06SetData(wLogSlot, wChData, wDaData) = 0 Then Exit Function

    Aisa06wSetData = True

End Function

'*****************************************************************************
'*    O͏Ԃ̎擾                                                 *
'*    wLogSlot _Xbg                                              *
'*        pdwCH1   CH1̏                                                 *
'*        pdwCH2   CH2̏                                                 *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Aisa06wGetCH(wLogSlot As Integer, pdwCH1 As Long, pdwCH2 As Long) As Boolean

    Aisa06wGetCH = False

    If hDLL = 0 Then Exit Function

    If Aisa06GetCH(wLogSlot, pdwCH1, pdwCH2) = 0 Then Exit Function

    Aisa06wGetCH = True

End Function

'*****************************************************************************
'*    aISA-A06W/H̃G[R[h                                          *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Aisa06wGetLastError(wLogSlot As Integer) As Long

    Aisa06wGetLastError = AISA06_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Aisa06wGetLastError = Aisa06GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Aisa06wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Aisa06wGetDllExportFunc = False

    ' Aisa06GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa06Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06Create")
    If pFunc = 0 Then Exit Function

    ' Aisa06Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06Close")
    If pFunc = 0 Then Exit Function

    ' Aisa06GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa06SetData ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06SetData")
    If pFunc = 0 Then Exit Function

    ' Aisa06GetCH ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06GetCH")
    If pFunc = 0 Then Exit Function

    ' Aisa06GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa06GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa06wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function

